



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Uva1001 Say Cheese Floyd</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Uva1001 Say Cheese Floyd</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 18:55:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意：一个无限大的奶酪里有n个球形的洞，在洞内可以瞬移，不然每一个单位要用10sec，现在给定起始点和结束点，问最短需要耗时多久？</p>
<p>思路：把球形的洞当做是节点，两点之间的距离是两者球心的距离减去两者的半径，因为n&lt;=100，所以可以用floyd算法来解决。但是需要注意有可能两个球相交，所以要考虑这种情况</p>
<div>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;string.h&gt;<br />
#include &lt;math.h&gt;<br />
#include &lt;queue&gt;<br />
#include &lt;map&gt;<br />
#include &lt;vector&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;iostream&gt;<br />
using namespace std;<br />
#define inf 0x3f3f3f3f<br />
typedef long long ll;<br />
const int maxn=;<br />
#define rep(i,n) for(int i=1;i&lt;=(n);i++) 

int n;

int x[maxn],y[maxn],z[maxn],r[maxn];

double dp[maxn][maxn];

double dis(int x1,int x2,int y1,int y2,int z1,int z2,int r1,int r2){<br />
    double res=sqrt(1.0*(x1-x2)*(x1-x2)+1.0*(y1-y2)*(y1-y2)+1.0*(z1-z2)*(z1-z2))-r1-r2;<br />
    if(res&gt;)return res;<br />
    else return ;<br />
}

void init(){<br />
    memset(dp,inf,sizeof(dp));<br />
    rep(i,n+){<br />
        for(int j=i+;j&lt;=n+;j++){<br />
            dp[i][j]=dp[j][i]=dis(x[i],x[j],y[i],y[j],z[i],z[j],r[i],r[j]);<br />
        }<br />
    }<br />
}

void floyd(){<br />
    rep(k,n+){<br />
        rep(i,n+){<br />
            rep(j,n+){<br />
                if(i!=j){<br />
                    dp[i][j]=min(dp[i][j],dp[i][k]+dp[k][j]);<br />
                }<br />
            }<br />
        }<br />
    }<br />
}

int main(){<br />
    int cas=;<br />
    while(scanf("%d",&amp;n)==&amp;&amp;n!=-){<br />
        rep(i,n)scanf("%d%d%d%d",&amp;x[i],&amp;y[i],&amp;z[i],&amp;r[i]);<br />
        for(int i=n+;i&lt;=n+;i++){<br />
            scanf("%d%d%d",&amp;x[i],&amp;y[i],&amp;z[i]);<br />
            r[i]=;<br />
        }<br />
        init();<br />
        floyd();<br />
        double res=dp[n+][n+]*;<br />
        printf("Cheese %d: Travel time = %.0f sec\n",cas,res);<br />
        cas++;<br />
    }<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m9600pn9.html">通过js实现回到顶部功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4o4rn8.html">生成API文档的软件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k123n69.html">C&num;&lowbar;自动化测试1&lowbar;模拟post&comma;get&lowbar;12306火车票网站自动登录工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde6ppv9.html">Unix&sol;Linux环境C编程入门教程&lpar;13&rpar; 开发环境搭建VMware软件安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgmpl8.html">&lbrack;51nod1474&rsqb;宝藏图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjpkxl8.html">数据库入门之运行原始 SQL 查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gewznz8.html">2016湖南省赛 &lbrack;Cloned&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zry4e9.html">django 2&period;接口之工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e47enk9.html">A1005&period; Spell It Right</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj7gzl9.html">C&num;动态代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r30749.html">远程桌面连接报错：出现身份验证错误，要求函数不受支持，由于CredSSP加密Oracle修正。</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pox6g8.html">&lbrack;技术&rsqb; OIer的C&plus;&plus;标准库 &colon; 字符串库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjevp0q.html">pyqt5-基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjzjlzq.html">NHibernate&period;Cfg&period;HibernateConfigException</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvejvzj9.html">hadoop学习笔记（十一）：MapReduce数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn4pk3q.html">angularJS1笔记-&lpar;3&rpar;-购物车增删改查练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2r1708.html">AC Again hdoj 1582 搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k10ylq.html">&lbrack;py&rsqb;&lbrack;mx&rsqb;django实现根据城市和课程机构类别过滤</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpwlrz9.html">html-头标签的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl33739.html">辣鸡蒟蒻Klaier的一些计划</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kokj46q.html">&lbrack;PHP&rsqb; Yaf框架的简单安装使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp7ply9.html">SQLite的Integer类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o43djlq.html">java的文件操作（1）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk6vld8.html">软件架构系列二：Clean架构</a>
			</li>
						<li><a href="https://www.batexi.com/a/9024jm4q.html">POJ3087&lpar;KB1-G 简单搜索&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvejzwy9.html">PHP中文件操作（1）--打开&sol;读取文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em35lm9.html">对MVC模式与MVVM模式的认识</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk64w18.html">Qt编译目录下exe文件执行报错问题的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e22w19.html">js 和springboot内存图</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vyy15q.html">Pig group用法举例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
